
import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * The interface of news server
 */
public interface NewsServerI extends Remote{
    /**
     * An RMI method for clients to subscribe and get ID
     * @param RMIAddress the RMI address of client
     * @return ID
     * @throws RemoteException if linke has problem
     */
    int subscribe(String RMIAddress) throws RemoteException;

    /**
     * An RMI method for clients to add keyword to its interests
     * @param subscribeID the client's ID
     * @param keyword Interested keyword
     * @throws RemoteException if link has problem
     */
    void declareInterest(int subscribeID, String keyword) throws RemoteException;
}
