
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.*;

/**
 * The GUI of the server implemented using SWT
 * @see MyServer
 */
public class ServerGUI {
    /**
     * The server that this GUI will be connected to it
     */
    static MyServer server;

    /**
     * The interface
     * @param args nothing
     */
    public static void main(String[] args) {
        final Display display = new Display();
        final Shell mainShell = new Shell(display, SWT.MIN | SWT.CLOSE);
        mainShell.setSize(190, 285);
        mainShell.setText("News Server");
        mainShell.setImage(new Image(display, "Feather.ico"));

        Composite table = new Composite(mainShell, SWT.BORDER);
        table.setBounds(9, 10, 165, 190);

        //DataBase IP
        Label dataBaseAddressIPLab = new Label(table, SWT.NONE);
        dataBaseAddressIPLab.setBounds(3, 3, 70, 17);
        dataBaseAddressIPLab.setText("Data Base IP: ");
        final Text dataBaseAddressIPText = new Text(table, SWT.BORDER);
        dataBaseAddressIPText.setBounds(87, 3, 70, 17);
        dataBaseAddressIPText.setTextLimit(15);

        //DataBase Port
        Label dataBaseAddressPortLab = new Label(table, SWT.NONE);
        dataBaseAddressPortLab.setBounds(3, 26, 78, 17);
        dataBaseAddressPortLab.setText("Data Base Port: ");
        final Text dataBaseAddressPortText = new Text(table, SWT.BORDER);
        dataBaseAddressPortText.setBounds(87, 26, 70, 17);
        dataBaseAddressPortText.setTextLimit(6);

        //DataBase Name
        Label dataBaseNameLab = new Label(table, SWT.NONE);
        dataBaseNameLab.setBounds(3, 49, 82, 17);
        dataBaseNameLab.setText("Data Base Name: ");
        final Text dataBaseNameText = new Text(table, SWT.BORDER);
        dataBaseNameText.setBounds(87, 49, 70, 17);
        dataBaseNameText.setTextLimit(15);

        //DataBase Username
        Label userNameLab = new Label(table, SWT.NONE);
        userNameLab.setBounds(3, 72, 70, 17);
        userNameLab.setText("DB User Name: ");
        final Text userNameText = new Text(table, SWT.BORDER);
        userNameText.setBounds(87, 72, 70, 17);
        userNameText.setTextLimit(15);

        //DataBase Password
        Label passwordLab = new Label(table, SWT.NONE);
        passwordLab.setBounds(3, 95, 78, 17);
        passwordLab.setText("DB Password: ");
        final Text passwordText = new Text(table, SWT.BORDER);
        passwordText.setEchoChar('*');
        passwordText.setBounds(87, 95, 70, 17);
        passwordText.setTextLimit(15);

        //RMI IP
        Label RMIAddressIPLab = new Label(table, SWT.NONE);
        RMIAddressIPLab.setBounds(3, 118, 70, 17);
        RMIAddressIPLab.setText("RMI Reg IP: ");
        final Text RMIAddressIPText = new Text(table, SWT.BORDER);
        RMIAddressIPText.setBounds(87, 118, 70, 17);
        RMIAddressIPText.setTextLimit(15);

        //RMI Port
        Label RMIAddressPortLab = new Label(table, SWT.NONE);
        RMIAddressPortLab.setBounds(3, 141, 78, 17);
        RMIAddressPortLab.setText("RMI Reg Port: ");
        final Text RMIAddressPortText = new Text(table, SWT.BORDER);
        RMIAddressPortText.setBounds(87, 141, 70, 17);
        RMIAddressPortText.setTextLimit(6);

        //RMI Name
        Label RMINameLab = new Label(table, SWT.NONE);
        RMINameLab.setBounds(3, 164, 78, 17);
        RMINameLab.setText("RMI Name: ");
        final Text RMINameText = new Text(table, SWT.BORDER);
        RMINameText.setBounds(87, 164, 70, 17);
        RMINameText.setTextLimit(15);

        //Start button
        final Button start = new Button(mainShell, SWT.PUSH);
        start.setText("Start");
        start.setLocation(10, 210);
        start.setSize(50, 20);

        //Stop button
        final Button stop = new Button(mainShell, SWT.PUSH);
        stop.setText("Stop");
        stop.setLocation(66, 210);
        stop.setSize(50, 20);
        stop.setEnabled(false);

        //Quit button
        final Button quit = new Button(mainShell, SWT.PUSH);
        quit.setText("Quit");
        quit.setLocation(122, 210);
        quit.setSize(50, 20);

        //Go button
        final Button go = new Button(mainShell, SWT.PUSH);
        go.setText("Go");
        go.setLocation(66, 235);
        go.setSize(50, 20);
        go.setEnabled(false);

        //Default values
//        dataBaseAddressIPText.setText("192.168.98.40");
        dataBaseAddressIPText.setText("194.225.68.96");
        dataBaseAddressPortText.setText("1433");
//        dataBaseNameText.setText("DBLABS8302");
//        userNameText.setText("DBLABS8302");
//        passwordText.setText("kami");
        dataBaseNameText.setText("ie");
        userNameText.setText("ie");
        passwordText.setText("ie");
        RMIAddressIPText.setText("localhost");
        RMIAddressPortText.setText("3131");
        RMINameText.setText("MyServer");

        start.addDisposeListener(new DisposeListener(){
            public void widgetDisposed(DisposeEvent event) {
                if(stop.getEnabled() == true && server != null) {
                    server.end();
                    server = null;
                }
            }
        });

        start.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent e) {
                String message = null;

                if (dataBaseAddressIPText.getText().length() <= 0)
                    message = "Data Base IP is empty";
                else if (dataBaseAddressPortText.getText().length() <= 0)
                    message = "Data Base Port is empty";
                else if (dataBaseNameText.getText().length() <= 0)
                    message = "Data Base Name is empty";
                else if (userNameText.getText().length() <= 0)
                    message = "User Name is empty";
                else if (passwordText.getText().length() <= 0)
                    message = "Password is empty";
                else if (RMIAddressIPText.getText().length() <= 0)
                    message = "RMI IP is empty";
                else if (RMIAddressPortText.getText().length() <= 0)
                    message = "RMI Port is empty";
                else if (RMINameText.getText().length() <= 0)
                    message = "RMI Name is empty";

                if (message != null) {
                    MessageBox mb = new MessageBox(mainShell, SWT.ICON_INFORMATION | SWT.OK);
                    mb.setMessage(message);
                    mb.open();
                    return;
                } else {
                    server = MyServer.getInstance(
                            RMINameText.getText(),
                            dataBaseAddressIPText.getText() + ":" + dataBaseAddressPortText.getText() + ";",
                            dataBaseNameText.getText(),
                            userNameText.getText(),
                            passwordText.getText(),
                            "//" + RMIAddressIPText.getText() + ":" + RMIAddressPortText.getText() + "/"
                    );

                    if(server == null)
                        return;

                    start.setEnabled(false);
                    stop.setEnabled(true);
                    go.setEnabled(true);
                }
            }
        });

        stop.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent e) {
                if(server != null) {
                    server.end();
                    server = null;
                }

                stop.setEnabled(false);
                go.setEnabled(false);
            }
        });

        quit.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent e) {
                if(server != null){
                    server.end();
                    server = null;
                }

                mainShell.close();
            }
        });

        go.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent e) {
                server.broadcastNews();
            }
        });

        mainShell.open();
        mainShell.setDefaultButton(start);

        while (!mainShell.isDisposed()) {
            if (!display.readAndDispatch())
                display.sleep();
        }

        display.close();
    }
}

